﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SerialCommApp.SeriallLibs
{
	public class PMessageHistory<T>
	{
        private List<T> _messageList;
        private int _size;

        public PMessageHistory(int size)
        {
            _size = size;
			_messageList = new List<T>(_size);
		}

		public void Add(T message)
        {
            if (_messageList.Count == 0)
                _messageList.Add(message);
            else
                _messageList.Insert(0, message);

            if (_messageList.Count <= _size)
                return;

            while (_messageList.Count > _size)
            {
                _messageList.RemoveAt(_messageList.Count);
            }
        }

        public T this[int index]
        {
            get { return _messageList[index]; }
        }

        public void Clear()
        {
            _messageList = new List<T>(_size);
        }

        public int Count { get { return _messageList.Count; } }
    }
}
